NB.
NB. J Numerical Math add-on
NB.
NB. (c) 2006 Konstantin L. Metlov <metlov@kinetic.ac.donetsk.ua>
NB.
NB. Portions (c) by their respective authors
NB. see the README file for details


require 'dll'

path =: jpath '~addons\jnum\'
sys=. (;:'Darwin Linux Win') i. <UNAME
bin=. > sys { 'jnum';'libjnum.so';'jnum.dll'
dll=: '"',path,bin,'" '

erase 'cdcallback'
cdcb5 =: cdcb 5
fc=: 3!:5
cvtCtF=: _2&fc
cvtFtC=:  2&fc
ic=: 3!:4
cvtCtI=: _2&ic
cvtItC=:  2&ic
output=: 2&((1!:2)~)
cb=: 1 : 0
   ptrndim=. 0 { y
   ndim=. cvtCtI memr ptrndim,0,4
   ptrin=. 1 { y
   xx=. cvtCtF memr ptrin,0,(ndim*8)
NB.   output xx
   ptrncomp=. 2 { y
   ncomp=. cvtCtI memr ptrncomp,0,4
NB.   output ncomp

   NB. evaluating the function of the data
   NB. ff=. (([: +/ %:), [: +/ *:) xx
   ff=. u xx

   NB. passing data back to C
   ff=. ncomp $ ff              NB. set the right dimension
   ptrout=. 3 { y               NB. pointer to receiving array
   (cvtFtC ff) memw ptrout,0,(ncomp*8)    NB. pass
)

NB. the right argument of the resulting verb is the
NB. xl yl zl ,: xh yh zh matrix of integration limits.
NB. Dimension of integral must be 2 or higher.
niCuhre =: 1 : 0
   assert. 2 = {. $ y        NB. matrix 2 x ndim

   cdcallback=: 1: [ u cb

   NB. get integration limits and dimensionality
   a =. {. y
   b =. {: y
   ndim =. #a                NB. dimension of integration

   NB. evaluate integrand in a middle point to get the
   NB. number of components
   t =. u -: +/ y
   assert. 1 >: # $ t        NB. integrand must be a list or atom
   ncomp =. # t              NB. number of components

   NB. prepare other input parameters
   epsrel=. 0.001
   epsabs=. 0.00001
   flags =. 0
   mineval =. 0
   maxeval =. 50000
   key =. 9

   par =. ndim;ncomp;cdcb5;a;b;epsrel;epsabs;flags;mineval;maxeval;key

   NB. output parameters
   nregions =. 1 $ 0
   neval =. 1 $ 0
   fail =. 1 $ 0
   integral =. ncomp $ 0
   error =. ncomp $ 0
   prob =. ncomp $ 0
   par =. par,nregions;neval;fail;integral;error;prob

   NB. output par
   
   cdcallback=: 1: [ u cb
   res=. (dll , 'jcuhre n i i i *d *d d d i i i i *i *i *i *d *d *d') cd par
   erase 'cdcallback'

   output res
   
   |: > 15 16 17 { res
)

NB. (([: +/ %:), [: +/ *:) niCuhre 0 0 ,: 2 2
